#ifndef PANGULU_GESSM_FP64_H
#define PANGULU_GESSM_FP64_H

#include "pangulu_common.h"
#include "pangulu_cuda_interface.h"
/*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_gessm_fp64(pangulu_Smatrix *A,
                            pangulu_Smatrix *L,
                            pangulu_Smatrix *X)
    {

        int_t *A_rowpointer = A->rowpointer;
        int_t *A_colindex=A->columnindex;
        calculate_type *A_value = X->value;
        int_t *L_colpointer = L->columnpointer;
        int_t *L_rowindex = L->rowindex;
        calculate_type *L_value = L->value_CSC;
        int_t *X_rowpointer = A->rowpointer;
        int_t *X_colindex=A->columnindex;
        calculate_type *X_value = A->value;
        int_t n = A->row;
        
        for(int_t i=0;i<A->nnz;i++){
            X_value[i]=0.0;
        }

        for (int_t i = 0; i < n; i++)
        {
            //X get value from A
            for (int_t k = X_rowpointer[i]; k < X_rowpointer[i + 1]; k++)
            {
                X_value[k] = A_value[k];
            }
            //update Value
            if (X_rowpointer[i] != X_rowpointer[i + 1])
                for (int_t j = L_colpointer[i]; j < L_colpointer[i + 1]; j++)
                {

                    for (int_t p = A_rowpointer[L_rowindex[j]], k = X_rowpointer[i]; p < A_rowpointer[L_rowindex[j] + 1]; p++, k++)
                    {
                        if(A_colindex[p] == X_colindex[k]){
                            A_value[p] -= L_value[j] * X_value[k];
                        }
                        else{
                            k--;
                        }
                    }
                }
        }
    }



#endif